#include <QtCore>
#include <QVector>
#include <QVector3D>
#include "orbit.h"
#include "orbitcloud.h"
#include <iostream>
using namespace std;

OrbitCloud::OrbitCloud(){}

void OrbitCloud::setQ(qreal q) {
  m_q = q;
}
  
void OrbitCloud::setMass(qreal m) {
  m_mass = m;
}

void OrbitCloud::leapfrog(qreal dt, int nstep){

      xs.clear(); vs.clear();

      Potential pot(m_mass,m_q);
      QVector3D x,v;

      for(int i=0;i<3;i++){
        qreal t = 0.0;
        x[0]=xin[i];x[1]=yin[i];x[2]=zin[i];
        v[0]=vxin[i];v[1]=vyin[i];v[2]=vzin[i];
  
        xs.append(x);
        vs.append(v);
  
        for(int n=0;n<nstep;n++) {
          x += 0.5*dt*v;
          t += 0.5*dt;
          v += dt*pot.accel(x);
          x += 0.5*dt*v;
          t += 0.5*dt;
          ts.append(t);
          xs.append(x);
          vs.append(v);
        }
      }
    }

